org.springframework.scheduling.quartz

## Class SimpleTriggerFactoryBean

- java.lang.Object
- - org.springframework.scheduling.quartz.SimpleTriggerFactoryBean

- All Implemented Interfaces:
    Aware, BeanNameAware, FactoryBean<SimpleTrigger>, InitializingBean

      public class SimpleTriggerFactoryBean
      extends Object
      implements FactoryBean<SimpleTrigger>, BeanNameAware, InitializingBean

  A Spring `FactoryBean` for creating a Quartz `SimpleTrigger` instance, supporting bean-style usage for trigger configuration.

  `SimpleTrigger(Impl)` itself is already a JavaBean but lacks sensible defaults. This class uses the Spring bean name as job name, the Quartz default group ("DEFAULT") as job group, the current time as start time, and indefinite repetition, if not specified.

  This class will also register the trigger with the job name and group of a given `JobDetail`. This allows `SchedulerFactoryBean` to automatically register a trigger for the corresponding JobDetail, instead of registering the JobDetail separately.

  NOTE: This FactoryBean works against both Quartz 1.x and Quartz 2.x, in contrast to the older `SimpleTriggerBean` class.

  Since:
    3.1
  Author:
    Juergen Hoeller
  See Also:
    `setName(java.lang.String)`, `setGroup(java.lang.String)`, `setStartDelay(long)`, `setJobDetail(org.quartz.JobDetail)`, `SchedulerAccessor.setTriggers(org.quartz.Trigger...)`, `SchedulerAccessor.setJobDetails(org.quartz.JobDetail...)`, `CronTriggerBean`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleTriggerFactoryBean()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
    `JobDataMap` | `getJobDataMap()` Return the trigger's JobDataMap.
    `SimpleTrigger` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<?>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setBeanName(String beanName)` Set the name of the bean in the bean factory that created this bean.
    `void` | `setDescription(String description)` Associate a textual description with this trigger.
    `void` | `setGroup(String group)` Specify the trigger's group.
    `void` | `setJobDataAsMap(Map<String,?> jobDataAsMap)` Register objects in the JobDataMap via a given Map.
    `void` | `setJobDataMap(JobDataMap jobDataMap)` Set the trigger's JobDataMap.
    `void` | `setJobDetail(JobDetail jobDetail)` Set the JobDetail that this trigger should be associated with.
    `void` | `setMisfireInstruction(int misfireInstruction)` Specify a misfire instruction for this trigger.
    `void` | `setMisfireInstructionName(String constantName)` Set the misfire instruction via the name of the corresponding constant in the `SimpleTrigger` class.
    `void` | `setName(String name)` Specify the trigger's name.
    `void` | `setPriority(int priority)` Specify the priority of this trigger.
    `void` | `setRepeatCount(int repeatCount)` Specify the number of times this trigger is supposed to fire.
    `void` | `setRepeatInterval(long repeatInterval)` Specify the interval between execution times of this trigger.
    `void` | `setStartDelay(long startDelay)` Set the start delay in milliseconds.
    `void` | `setStartTime(Date startTime)` Set a specific start time for the trigger.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SimpleTriggerFactoryBean

          public SimpleTriggerFactoryBean()

  - ### Method Detail

    - #### setName

          public void setName(String name)

      Specify the trigger's name.

    - #### setGroup

          public void setGroup(String group)

      Specify the trigger's group.

    - #### setJobDetail

          public void setJobDetail(JobDetail jobDetail)

      Set the JobDetail that this trigger should be associated with.

    - #### setJobDataMap

          public void setJobDataMap(JobDataMap jobDataMap)

      Set the trigger's JobDataMap.
      See Also:
        `setJobDataAsMap(java.util.Map<java.lang.String, ?>)`

    - #### getJobDataMap

          public JobDataMap getJobDataMap()

      Return the trigger's JobDataMap.

    - #### setJobDataAsMap

          public void setJobDataAsMap(Map<String,?> jobDataAsMap)

      Register objects in the JobDataMap via a given Map.

      These objects will be available to this Trigger only, in contrast to objects in the JobDetail's data map.

      Parameters:
        `jobDataAsMap` - Map with String keys and any objects as values (for example Spring-managed beans)
      See Also:
        `JobDetailBean.setJobDataAsMap(java.util.Map<java.lang.String, ?>)`

    - #### setStartTime

          public void setStartTime(Date startTime)

      Set a specific start time for the trigger.

      Note that a dynamically computed `setStartDelay(long)` specification overrides a static timestamp set here.

    - #### setStartDelay

          public void setStartDelay(long startDelay)

      Set the start delay in milliseconds.

      The start delay is added to the current system time (when the bean starts) to control the start time of the trigger.

      See Also:
        `setStartTime(java.util.Date)`

    - #### setRepeatInterval

          public void setRepeatInterval(long repeatInterval)

      Specify the interval between execution times of this trigger.

    - #### setRepeatCount

          public void setRepeatCount(int repeatCount)

      Specify the number of times this trigger is supposed to fire.

      Default is to repeat indefinitely.

    - #### setPriority

          public void setPriority(int priority)

      Specify the priority of this trigger.

    - #### setMisfireInstruction

          public void setMisfireInstruction(int misfireInstruction)

      Specify a misfire instruction for this trigger.

    - #### setMisfireInstructionName

          public void setMisfireInstructionName(String constantName)

      Set the misfire instruction via the name of the corresponding constant in the `SimpleTrigger` class. Default is `MISFIRE_INSTRUCTION_SMART_POLICY`.
      See Also:
        `SimpleTrigger.MISFIRE_INSTRUCTION_FIRE_NOW`, `SimpleTrigger.MISFIRE_INSTRUCTION_RESCHEDULE_NEXT_WITH_EXISTING_COUNT`, `SimpleTrigger.MISFIRE_INSTRUCTION_RESCHEDULE_NEXT_WITH_REMAINING_COUNT`, `SimpleTrigger.MISFIRE_INSTRUCTION_RESCHEDULE_NOW_WITH_EXISTING_REPEAT_COUNT`, `SimpleTrigger.MISFIRE_INSTRUCTION_RESCHEDULE_NOW_WITH_REMAINING_REPEAT_COUNT`, `Trigger.MISFIRE_INSTRUCTION_SMART_POLICY`

    - #### setDescription

          public void setDescription(String description)

      Associate a textual description with this trigger.

    - #### setBeanName

          public void setBeanName(String beanName)

      Description copied from interface: `BeanNameAware`
      Set the name of the bean in the bean factory that created this bean.

      Invoked after population of normal bean properties but before an init callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

      Specified by:
        `setBeanName` in interface `BeanNameAware`
      Parameters:
        `beanName` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.

    - #### afterPropertiesSet

          public void afterPropertiesSet()

      Description copied from interface: `InitializingBean`
      Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

      This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`

    - #### getObject

          public SimpleTrigger getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<SimpleTrigger>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<?> getObjectType()

      Description copied from interface: `FactoryBean`
      Return the type of object that this FactoryBean creates, or `null` if not known in advance.

      This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

      In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

      This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

      NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

      Specified by:
        `getObjectType` in interface `FactoryBean<SimpleTrigger>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<SimpleTrigger>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`